<?php

namespace App\Controller;

use App\Gateway\AuthGateway;
use App\Http\HttpResponse;
use App\Model\AuthModel;
use Twig\Environment;

class AuthController {
    private AuthModel $model;

    /**
     * @param AuthModel $model
     */
    public function __construct(AuthModel $model) {
        $this->model = $model;
    }

    public function displayRegister() {
        echo $this->twig->render("display_register.html.twig", []);
    }

    public function confirmRegister(array $request): HttpResponse {

        


        if (isset($request['username']) && isset($request['password']) && isset($request['confirmpassword']) && isset($request['email'])) {
            $errors = $this->model->validationRegister($request['username'],$request["password"], $request['confirmpassword'],$request['email']);

            if (empty($errors)) {
                echo $this->twig->render("display_register_confirm.html.twig", [$request]);
            } else {
                $bad_fields = [];

                foreach ($errors as $error_code) {
                    switch ($error_code) {
                        case AuthModel::PASSWORD_CONFIRM_NOT_EQUALS:
                            $bad_fields[] = "password";
                            $bad_fields[] = "confirmpassword";
                            break;

                    }
                }
                echo $this->twig->render("display_register.html.twig", ['bad_fields' => $bad_fields]);
            }

            return ;
        }
        // Invalid request shape

        http_response_code(400);
        echo "la requêtte est invalide";
    }


}